#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>       //Download: https://www.electronoobs.com/eng_arduino_Adafruit_GFX.php
#include <Adafruit_SSD1306.h>   //Downlaod: https://www.electronoobs.com/eng_arduino_Adafruit_SSD1306.php
Adafruit_SSD1306 display(4);    //Create screen variable


#include <Wire.h>
#include <Adafruit_ADS1015.h>   //Download: https://electronoobs.com/eng_arduino_Adafruit_ADS1015.php
Adafruit_ADS1115 ads(0x48);
Adafruit_ADS1115 ads2(0x49);
const float multiplier = 0.1875F;   //From datasheet


//Define all the Input/output pins of the board
int D2 = 2;     //MUX 1
int D3 = 3;     //MUX 2
int D4 = 4;     //Resistance 20K
int D5 = 5;     //Resistance 470K
int D6 = 6;     //Inductance pulse
int D7 = 7;     //Voltage divider R
int D8 = 8;     //Resistance 2K
int D9 = 9;     //Inductance out
int D10 = 10;   //Push button
int D11 = 11;   //Capacitance 10K
int D12 = 12;   //Voltage divider L
int D13 = 13;   //Capacitance 220K
int a0 = A0;    //Capacitance Read
int a1 = A1;    //Resistance diode 
int a2 = A2;    //Capacitance RC
int a3 = A3;    //MUX 0
int a6 = A6;    
int a7 = A7;

//Current mode variables
float Sensibility = 0.185;   //Given by the ACS712 datasheet


void setup() {
  Serial.begin(9600);
  //Define all pins as inputs but not the pins that we will use
  pinMode(a0, INPUT);
  pinMode(a1, INPUT);
  pinMode(a2, INPUT);
  pinMode(a3, INPUT);
  pinMode(a6, INPUT);
  pinMode(a7, INPUT);  
  pinMode(D2, INPUT);
  pinMode(D3, INPUT);
  pinMode(D4, INPUT);
  pinMode(D5, INPUT);
  pinMode(D6, INPUT);
  pinMode(D7, INPUT);
  pinMode(D8, INPUT);
  pinMode(D9, INPUT);
  pinMode(D10, INPUT);
  pinMode(D11, INPUT);
  pinMode(D12, INPUT);
  pinMode(D13, INPUT);

  ads.begin();  //Start i2c communication with the first ADS1115
  ads2.begin();  //Start i2c communication with the second ADS1115
  
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  //Start i2c communication
  display.setRotation(2);                     //Rotate screen 180 degree
  display.clearDisplay();                     //Clear the display data
  display.display();                          //Send data to the display
  delay(10);

}

void loop() {
  //MUX setup
  pinMode(a3, OUTPUT);  //S0 of mux
  pinMode(D2, OUTPUT);  //S1 of mux
  pinMode(D3, OUTPUT);  //S2 of mux
  //We set "000" so we activate MUX1 for Current mode (A)
  digitalWrite(a3, LOW);   //S0 to 1
  digitalWrite(D2, LOW);    //S1 to 0
  digitalWrite(D3, LOW);    //S2 to 0

  int read_loop = 0;
  float Sens_volt = 0;
  while(read_loop < 100)
  {
    float adc3; // Leemos el ADC, con 16 bits    
    adc3 = ads.readADC_SingleEnded(3);
    Sens_volt = Sens_volt + ( (adc3 * 0.1875)/1000 );   
    read_loop = read_loop + 1;
  } 

  //We read the VCC voltage
  float adc4; 
  adc4 = ads2.readADC_SingleEnded(0);
  float VccVoltage = (adc4 * 0.1875)/1000;
  VccVoltage = VccVoltage * 4.09;
  Serial.println(VccVoltage);
  float VccVoltageHalf = (VccVoltage/2.0)-0.0155;
  
    
  Sens_volt = Sens_volt/100;
  Serial.println(Sens_volt); 
  float I =  1000*((Sens_volt - VccVoltageHalf)/Sensibility); //Ecuación  para obtener la corriente
 
  
  Serial.print(I,3); 
  Serial.println(" mA");   
  display.clearDisplay();  
  display.setTextSize(2);
  display.setTextColor(WHITE);    
  display.setCursor(10,0);
  display.print(" CURRENT");
        
  display.setTextSize(2);
  display.setTextColor(WHITE);    
  display.setCursor(0,18);
  display.print(I,0);
  display.println(" mA");
  display.display();  
  delay(50);  
  
}
